;10/10/20 shifting is proportional to how many characters are non-blank
;  more non-blank characters, slower the shift (think freight train)
;10/2/20
;Playing with the splash screen
;Do Vortex where lines of different angles are shifted into designated point
; a byte seed value is break into x,y components; msb of the nibble is sign,
; 2 bits of significance 
;  shift algorithm:
;  compare X, Y; if equal, shift diagnoally
;  shift the bigger value first.
;  decrement bigger value by one, then look at the smaller value.  If smaller value is 
;   non zero, do diagnoal shift.  XY are non zero after the diagnoal shift, do another shift.
;  
line1_4	equ 20h		;first 4 lines (1 to 4)
line45_48	equ 2bh		;last 4 lines (45 to 48)

font001f	equ 2ch		;font char 0-1F
font203f	equ 2dh		;font char 20-3F
font405f	equ 2eh		;font char 40-5F
font607f	equ 2fh		;font char 60-7F
cin	equ 0bb7ch	;character input in reg A
cout	equ 0bb91h	;char output in reg A
hexout	equ 0baebh	;output regA as ascii hex values

	org 1000h
	jp start
oldSeed	db 023h		;starting point
seed	ds 1
cursor	ds 2
cCall	db 0		;keep track of how many times called
pIX	ds 80		;value of reg BC, current seed value, cNxtSeg value.
chkBlank	ds 1		;check if entire line is blank
cNxtLine	ds 1		;keep track of how many time nxtLine is called
cNxtSeg	ds 1		;count how many time nexSeg is called
cDelay	ds 2		;how long to delay between each shift
	
start:
	ld sp,0f00h	;initialize stack pointer
	xor a
	ld (cNxtLine),a	;clear the counter that track how many time nxtLine is called
;	ld a,80h
;	ld (cDelay+1),a	;set initial delay to 0x8000
doVortex
;start from lower left of screen
	ld c,line45_48
	ld b,192		
	ld h,b		;HL is previous cursor 
	ld l,c
	xor a
	ld (chkBlank),a	;keep track of whether a line is all blank
	ld a,(oldSeed)
	ld (seed),a
	ld a,9
	ld (cNxtSeg),a
nxtSeg:
	xor a
	ld d,a
	ld a,(cNxtSeg)	;shift in one of 7 directions for cNxtSeg times
			;before random direction
          dec a
	jr z,nxtSeg1
	ld (cNxtSeg),a	;save cNxtSeg count if not zero
	ld a,(seed)
	jr nxtSeg2
nxtSeg1:
;random direction
	ld a,(seed)	;get the seed value 
	add 17		;a prime number
	ld (seed),a
nxtSeg2:
	rla
	rla
	rla
	rl d		;two bits from high nibble to D
	rla
	rl d
	ld a,(seed)
	and 3		;two bits from low nibble to E
	ld e,a
	cp d
	jr z,shftdiag	;E=D, diagonal shift
	jr c,shftLeft		;E lesser than D
;E is greater than D
;shift down first
; the remaining possibility after the first left shift are:
;  d=2,e=2 do diagonal shift
;  d=1,e=2 also do diagonal shift
;  d=0,e=2 do more down shift
;  d=1,e=1 do diagonal shift
;  d=0,e=1 do down shift
;  e=0 done
; so check d, if non zero, do a diagonal shift
;   else d=0 do down shift until e=0
	call shftCharDown
	jp z,lineDone	;if border reached, the line is finished
	dec e
	jr z,nxtSeg
	xor a
	or d		;check whether D=0
	jr z,sDown
	call shftCharDiag
	jp z,lineDone	;if border reached, the line is finished
	dec e
	dec d
	jr z,sDown
	call shftCharDiag
	jp z,lineDone	;if border reached, the line is finished
	jr nxtSeg
sDown:
	call shftCharDown
	jp z,lineDone	;if border reached, the line is finished
	dec e
	jr z,nxtSeg
	call shftCharDown
	jp z,lineDone	;if border reached, the line is finished
	jr nxtSeg	
shftdiag:
;diagnal shifting 
	call shftCharDiag
	jp z,lineDone	;if border reached, the line is finished
	dec d
	dec e
	jr z,nxtSeg
	jr shftdiag
shftLeft:
;shift left first,
; the remaining possibility after the first left shift are:
;  d=2,e=2 do diagonal shift
;  d=2,e=1 also do diagonal shift
;  d=2,e=0 do more left shift
;  d=1,e=1 do diagonal shift
;  d=1,e=0 do left shift
;  d=0 done
; so check e, if non zero, do a diagonal shift
;   else e=0 do left shift until d=0
	call shftCharLeft
	jp z,lineDone	;if border reached, the line is finished
	dec d
	jr z,nxtSeg
	xor a
	or e		;check whether E=0
	jr z,sLeft
	call shftCharDiag
	jp z,lineDone	;if border reached, the line is finished
	dec d
	dec e
	jr z,sLeft
	call shftCharDiag
	jp z,lineDone	;if border reached, the line is finished
	jp nxtSeg
sLeft:
	call shftCharLeft
	jp z,lineDone	;if border reached, the line is finished
	dec d
	jp z,nxtSeg
	call shftCharLeft
	jp z,lineDone	;if border reached, the line is finished
	jp nxtSeg

lineDone:
	ld a,(chkBlank)	;was the line completely blank?
	or a
	jp z,nxtLine
	add a
	add a
	ld (cDelay+1),a
	call delay
	jp doVortex
nxtLine:
;do another line
	ld a,(cNxtLine)	;when nxtLine is called more than 10 times, shift the entire screen
			;down and left
	inc a
	ld (cNxtLine),a
	cp 20		;nxtLine called 20 times?
	jp z,shrink
	ld a,(oldSeed)
	add 37		;update seed with a prime number
	ld (oldSeed),a
	jp doVortex
shrink:
;move entire screen one character down and one character left
	xor a
	ld (cNxtLine),a	;clear the cNxtLine counter
	ld c,line1_4
	push de
shrinkBO4
	ld b,0
	ld d,63
	call shrinkLeft1line
	ld b,64
	ld d,63
	call shrinkLeft1line
	ld b,128
	ld d,63
	call shrinkLeft1line
	ld b,192
	ld d,63
	call shrinkLeft1line
	inc c
	ld a,c
	cp line45_48+1
	jr nz,shrinkBO4

;move the entire screen down one line, start with the last line
	ld d,191		;source is D
	ld e,255		;destination is E

	ld c,line45_48
cp3lines:
	ld b,d		;point to source
	in a,(c)		;get character from next line
	ld b,e		;point to destination
	out (c),a		;write char to destination
	dec e		;increment source & destination
	dec d
	ld a,d
	cp 0ffh
	jr nz,cp3lines	;do this for 3 lines
cp1stline:
;1st line source is last line of previous block of 4 lines
	ld a,c		;check to see if this is the 1st block-of-4
	cp line1_4
	jr z,blankline
	dec c		;next block of 4 lines
	ld b,d
	in a,(c)
	ld b,e
	inc c		;destination is last line of previous block of 4 lines
	out (c),a
	dec d
	dec e
	ld a,e
	cp 0ffh
	jr nz,cp1stline
	dec c
	jr nz,cp3lines
;clear the 1st line
	ld a,' '
	inc e
	ld b,e
blankline:
	dec b
	out (c),a
	jr nz,blankline

;;move the entire screen down one row
;	ld b,128
;	ld d,64
;	call shrinkDown1line
	pop de
	jp doVortex

shrinkLeft1line:
;shift one line left by 1 character
	inc b
	in a,(c)		
	dec b
	out (c),a
	inc b
	dec d
	jr nz,shrinkLeft1line
	ret
shrinkDown1line:
;shift 1 line down


shftCharLeft:
;shift character left
	inc b
	jp shftChar	;will ret to calling routine

shftCharDiag:
;diagonal shift
	ld a,b		;see if reg B is lesser than 64
	and 0c0h
	jr z,prevBO4diag
	ld a,b		;subtract 63 from B
	ld b,63
	sub b
	ld b,a
	jp shftChar	;will ret to calling routine
prevBO4diag:
	dec c
	ld a,b
	or 0c0h		;add 193 to regB
	inc a		
	ld b,a
	jp shftChar	;will ret to calling routine

shftCharDown:
;shift character down one row from cursor
;update the previous cursor
	ld a,b		;see if reg B is lesser than 64
	and 0c0h
	jr z,prevBO4down	;B lesser than 64, so go to previous block-of-4
	ld a,b		;subtract 64 from B
	ld b,64
	sub b
	ld b,a
	jp shftChar	;will ret to calling routine
prevBO4down:
;shift to previous block-of-4
	dec c
	ld a,b
	or 0c0h		;add 192 to regB
	ld b,a
	jp shftChar	;will ret to calling routine

shftChar:
;regBC is pointing at source character, regHL is pointing at destination location
;shift character from previous cusor to current cursor, overwrite current cursor value
;update previous cursor with current cursor
	in a,(c)		;get target character
	push bc
	ld b,h		;get previous cursor into BC
	ld c,l
	out (c),a
	pop bc
	ld h,b		;update previous cursor with current one
	ld l,c
	cp ' '		;check if character is blank or lower value
	jr c,chkBorder
	jr z,chkBorder
	ld a,(chkBlank)	;if not blank, increment blank check counter
	inc a
	ld (chkBlank),a
chkBorder:
	ld a,c
	cp line1_4
	jr nz,chkB
;if first BO4, check B<64
	ld a,b
	and 0c0h
	jr nz,NotEnd
	xor a
	out (c),a
	ret
chkB:
;check if B=63,127,191,255
	ld a,b
	and 3fh
	cp 03fh
	jr nz,NotEnd
	xor a
	out (c),a
	ret
NotEnd:
	xor a
	inc a
	ret

;check cursor at the border where B=63,127,191,or255 or when C=line1_4 and B<64
	ld a,b
	and 3fh		;is B=63,127,191,or 255?
	inc a
	ret z
	ld a,b
	and 0c0h
	ret nz
	ld a,c
	cp line1_4	;set flag
	ret 
delay:
;16-bit delay
	push de
	ld de,(cDelay)
delay1:
	dec de
	ld a,d
	or e
	jr nz,delay1
	pop de
	ret


	end


